
log("SJNP - SUCCESSFULLY HOOKED GROUPAITWEAKDATA")

-- Difficulty Cheat Sheet:
-- NAME			ID	STRING
-- Normal		2	normal
-- Hard			3	hard
-- Very Hard	4	overkill
-- Overkill		5	overkill_145
-- Mayhem		6	easy_wish
-- Death Wish	7	overkill_290
-- Death Sent	8	sm_wish

-- Unit Category Cheat Sheet:
-- CS_cop_C45_R870		Police HRT 1
-- CS_cop_stealth_MP5	Police HRT 2
-- CS_swat_MP5			Blue SWAT
-- CS_swat_R870			Blue SWAT (Shotgun)
-- CS_heavy_M4			Yellow SWAT
-- CS_heavy_R870		Yellow SWAT (Shotgun)
-- CS_shield			Shield
-- CS_tazer				Taser
-- FBI_suit_C45_M4		FBI HRT 1
-- FBI_suit_M4_MP5		FBI HRT 2
-- FBI_suit_stealth_MP5	FBI HRT 3
-- FBI_swat_M4			FBI/GenSec SWAT
-- FBI_swat_R870		FBI/GenSec SWAT (Shotgun)
-- FBI_heavy_G36		FBI/GenSec MFR
-- FBI_heavy_R870		FBI/GenSec MFR (Shotgun)
-- FBI_shield			FBI/GenSec Shield
-- FBI_tank				Bulldozer
-- spooc				Cloaker
-- medic_M4				Medic
-- medic_R870			Medic (Shotgun)

-- The following are unused, don't bother with them.
-- CS_heavy_M4_w
-- FBI_heavy_G36_w

Hooks:PostHook(GroupAITweakData, "_init_unit_categories", "NewPoliciaUnits", function(self, difficulty_index)
	
	local fallbackunit = {Idstring("units/pd2_dlc_bex/characters/sjnp_swat_light_3/sjnp_swat_light_3")}
	
	-- Global all difficulty units
	self.unit_categories.CS_cop_C45_R870.unit_types.federales = {
		Idstring("units/pd2_dlc_bex/characters/sjnp_beatcop_1/sjnp_beatcop_1"),
		Idstring("units/pd2_dlc_bex/characters/sjnp_beatcop_2/sjnp_beatcop_2")
	}
	
	self.unit_categories.CS_cop_stealth_MP5.unit_types.federales = {
		Idstring("units/pd2_dlc_bex/characters/sjnp_beatcop_3/sjnp_beatcop_3"),
		Idstring("units/pd2_dlc_bex/characters/sjnp_beatcop_4/sjnp_beatcop_4")
	}
	
	self.unit_categories.FBI_suit_C45_M4.unit_types.federales = {
		Idstring("units/pd2_dlc_bex/characters/sjnp_hrt_1/sjnp_hrt_1")
	}
	
	self.unit_categories.FBI_suit_M4_MP5.unit_types.federales = {
		Idstring("units/pd2_dlc_bex/characters/sjnp_hrt_2/sjnp_hrt_2")
	}
	
	self.unit_categories.FBI_suit_stealth_MP5.unit_types.federales = {
		Idstring("units/pd2_dlc_bex/characters/sjnp_hrt_3/sjnp_hrt_3")
	}
	
	-- Normal / Hard / Very Hard / Overkill - Policía Federal
	if difficulty_index <= 5 then
		
		self.unit_categories.CS_swat_MP5.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_light_1/sjnp_swat_light_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_light_2/sjnp_swat_light_2")
		}
		
		self.unit_categories.CS_swat_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_light_3/sjnp_swat_light_3")
		}
		
		self.unit_categories.CS_heavy_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_medium_1/sjnp_swat_medium_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_medium_2/sjnp_swat_medium_2")
		}
		
		self.unit_categories.CS_heavy_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_medium_1/sjnp_swat_medium_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_medium_2/sjnp_swat_medium_2")
		}
		
		self.unit_categories.CS_tazer.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_taser/sjnp_swat_taser")
		}
		
		self.unit_categories.CS_shield.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_shield_small_bearer/sjnp_swat_shield_small_bearer")
		}
		
		self.unit_categories.FBI_swat_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_heavy_1/sjnp_swat_heavy_1")
		}
		
		self.unit_categories.FBI_swat_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_heavy_2/sjnp_swat_heavy_2")
		}
		
		self.unit_categories.FBI_heavy_G36.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_mfr/sjnp_swat_mfr")
		}
		
		self.unit_categories.FBI_heavy_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_mfr/sjnp_swat_mfr")
		}
		
		self.unit_categories.FBI_shield.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_shield_large_bearer/sjnp_swat_shield_large_bearer")
		}
		
		self.unit_categories.FBI_tank.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_bulldozer/sjnp_swat_bulldozer")
		}
		
		self.unit_categories.spooc.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_cloaker/sjnp_swat_cloaker")
		}
		
		self.unit_categories.medic_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_medic/sjnp_swat_medic")
		}
		
		self.unit_categories.medic_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_medic/sjnp_swat_medic")
		}
	end
	
	-- Mayhem / Death Wish - Gendarmería Nacional
	if difficulty_index == 6 or difficulty_index == 7 then
		
		fallbackunit = {Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_light_1/sjnp_gendarmeria_light_1")}
		
		self.unit_categories.FBI_swat_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_light_1/sjnp_gendarmeria_light_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_light_2/sjnp_gendarmeria_light_2")
		}
		
		self.unit_categories.FBI_swat_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_light_2/sjnp_gendarmeria_light_2")
		}
		
		self.unit_categories.FBI_heavy_G36.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_mfr/sjnp_gendarmeria_mfr")
		}
		
		self.unit_categories.FBI_heavy_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_mfr/sjnp_gendarmeria_mfr")
		}
		
		self.unit_categories.CS_tazer.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_taser/sjnp_gendarmeria_taser")
		}
		
		self.unit_categories.CS_shield.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_shield_large_bearer/sjnp_gendarmeria_shield_large_bearer")
		}
		
		self.unit_categories.FBI_shield.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_shield_large_bearer/sjnp_gendarmeria_shield_large_bearer")
		}
		
		-- Vanilla doesn't have LMG dozers on Mayhem, so emulate that here
		if difficulty_index == 6 then
		self.unit_categories.FBI_tank.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_bulldozer_1/sjnp_gendarmeria_bulldozer_1")
		}
		else
		self.unit_categories.FBI_tank.unit_types.federales = {
			-- Make it a 1/3 chance of spawning w LMG instead of 1/2
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_bulldozer_1/sjnp_gendarmeria_bulldozer_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_bulldozer_1/sjnp_gendarmeria_bulldozer_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_bulldozer_2/sjnp_gendarmeria_bulldozer_2")
		}
		end
		
		self.unit_categories.spooc.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_swat_cloaker/sjnp_swat_cloaker")
		}
		
		self.unit_categories.medic_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_medic/sjnp_gendarmeria_medic")
		}
		
		self.unit_categories.medic_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_gendarmeria_medic/sjnp_gendarmeria_medic")
		}
	end
	
	-- Death Sentence - Infantería de Marina
	if difficulty_index >= 8 then
		
		fallbackunit = {Idstring("units/pd2_dlc_bex/characters/sjnp_marina_light/sjnp_marina_light")}
		
		self.unit_categories.FBI_swat_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_light/sjnp_marina_light")
		}
		
		self.unit_categories.FBI_swat_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_light/sjnp_marina_light")
		}
		
		self.unit_categories.FBI_heavy_G36.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_mfr/sjnp_marina_mfr")
		}
		
		self.unit_categories.FBI_heavy_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_mfr/sjnp_marina_mfr")
		}
		
		self.unit_categories.CS_tazer.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_taser/sjnp_marina_taser")
		}
		
		self.unit_categories.CS_shield.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_shield_large_bearer/sjnp_marina_shield_large_bearer")
		}
		
		self.unit_categories.FBI_shield.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_shield_large_bearer/sjnp_marina_shield_large_bearer")
		}
		
		self.unit_categories.FBI_tank.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_bulldozer_1/sjnp_marina_bulldozer_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_bulldozer_1/sjnp_marina_bulldozer_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_bulldozer_1/sjnp_marina_bulldozer_1"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_bulldozer_medic/sjnp_marina_bulldozer_medic"),
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_bulldozer_2/sjnp_marina_bulldozer_2")
		}
		
		self.unit_categories.spooc.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_cloaker/sjnp_marina_cloaker")
		}
		
		self.unit_categories.medic_M4.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_medic/sjnp_marina_medic")
		}
		
		self.unit_categories.medic_R870.unit_types.federales = {
			Idstring("units/pd2_dlc_bex/characters/sjnp_marina_medic/sjnp_marina_medic")
		}
	end
	
	if difficulty_index > 5 then
		-- These units shouldn't spawn at all above Overkill, but just in case
		self.unit_categories.CS_swat_MP5.unit_types.federales = fallbackunit
		self.unit_categories.CS_swat_R870.unit_types.federales = fallbackunit
		self.unit_categories.CS_heavy_M4.unit_types.federales = fallbackunit
		self.unit_categories.CS_heavy_R870.unit_types.federales = fallbackunit
	end
end)

Hooks:PostHook(GroupAITweakData, "_init_enemy_spawn_groups", "NewPoliciaGroups", function(self, difficulty_index)
	
	-- Normal = Basic Police HRT, No Tasers
	if difficulty_index <= 2 then
		self.enemy_spawn_groups.tac_tazer_flanking = {
			amount = {
				5,
				6
			},
			spawn = {
				{
					amount_min = 3,
					freq = 1,
					amount_max = 4,
					rank = 1,
					unit = "CS_cop_C45_R870",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 2,
					unit = "CS_cop_stealth_MP5",
					tactics = self._tactics.tazer_charge
				}
			}
		}
	-- Hard = Police HRT + FBI Support
	elseif difficulty_index == 3 then
		self.enemy_spawn_groups.tac_tazer_flanking = {
			amount = {
				6,
				6
			},
			spawn = {
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 3,
					unit = "CS_tazer",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 2,
					freq = 1,
					amount_max = 2,
					rank = 1,
					unit = "CS_cop_C45_R870",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 2,
					freq = 1,
					amount_max = 2,
					rank = 2,
					unit = "CS_cop_stealth_MP5",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 1,
					unit = "FBI_suit_C45_M4",
					tactics = self._tactics.tazer_charge
				}
			}
		}
	-- Very Hard = FBI HRT
	elseif difficulty_index == 3 then
		self.enemy_spawn_groups.tac_tazer_flanking = {
			amount = {
				7,
				7
			},
			spawn = {
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 3,
					unit = "CS_tazer",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 2,
					unit = "FBI_suit_C45_M4",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 3,
					freq = 1,
					amount_max = 3,
					rank = 2,
					unit = "FBI_suit_M4_MP5",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 2,
					freq = 1,
					amount_max = 2,
					rank = 1,
					unit = "FBI_suit_stealth_MP5",
					tactics = self._tactics.tazer_charge
				}
			}
		}
	-- Overkill = FBI Heavy HRT
	elseif difficulty_index == 4 then
		self.enemy_spawn_groups.tac_tazer_flanking = {
			amount = {
				7,
				7
			},
			spawn = {
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 3,
					unit = "CS_tazer",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 4,
					freq = 1,
					amount_max = 4,
					rank = 2,
					unit = "FBI_suit_stealth_MP5",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 2,
					freq = 1,
					amount_max = 2,
					rank = 1,
					unit = "FBI_suit_M4_MP5",
					tactics = self._tactics.tazer_charge
				}
			}
		}
	else
		self.enemy_spawn_groups.tac_tazer_flanking = {
			amount = {
				7,
				7
			},
			spawn = {
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 3,
					unit = "CS_tazer",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 3,
					unit = "medic_m4",
					tactics = self._tactics.tazer_charge
				},
				{
					amount_min = 5,
					freq = 1,
					amount_max = 5,
					rank = 2,
					unit = "FBI_suit_stealth_MP5",
					tactics = self._tactics.tazer_charge
				}
			}
		}
	end
	
	-- Fix FBI shields appearing on Normal/Hard
	if difficulty_index <= 3 then
		self.enemy_spawn_groups.tac_shield_wall = {
			amount = {
				4,
				4
			},
			spawn = {
				{
					amount_min = 4,
					freq = 1,
					amount_max = 4,
					rank = 3,
					unit = "CS_shield",
					tactics = self._tactics.shield_wall
				}
			}
		}
	end
	
	-- For some reason we can't re-add tac_swat_shotgun_rush and tac_swat_shotgun_flank, so
	-- just sprinkle a little bit in with the standard spawngroup.
	if difficulty_index <= 2 then
		self.enemy_spawn_groups.tac_swat_rifle_flank = {
			amount = {
				3,
				3
			},
			spawn = {
				{
					amount_min = 2,
					freq = 1,
					amount_max = 2,
					rank = 2,
					unit = "CS_swat_MP5",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 0,
					freq = 0.5,
					amount_max = 1,
					rank = 3,
					unit = "CS_swat_R870",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 0,
					freq = 0.5,
					amount_max = 1,
					rank = 3,
					unit = "CS_heavy_M4",
					tactics = self._tactics.swat_rifle_flank
				}
			}
		}
	elseif difficulty_index == 3 then
		self.enemy_spawn_groups.tac_swat_rifle_flank = {
			amount = {
				4,
				4
			},
			spawn = {
				{
					amount_min = 2,
					freq = 1,
					amount_max = 2,
					rank = 2,
					unit = "CS_swat_MP5",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 1,
					freq = 0.5,
					amount_max = 2,
					rank = 3,
					unit = "CS_swat_R870",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 1,
					freq = 1,
					amount_max = 2,
					rank = 3,
					unit = "CS_heavy_M4",
					tactics = self._tactics.swat_rifle_flank
				}
			}
		}
	elseif difficulty_index == 4 then
		self.enemy_spawn_groups.tac_swat_rifle_flank = {
			amount = {
				4,
				4
			},
			spawn = {
				{
					amount_min = 2,
					freq = 1,
					amount_max = 3,
					rank = 2,
					unit = "FBI_swat_M4",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 0,
					freq = 0.5,
					amount_max = 1,
					rank = 2,
					unit = "FBI_swat_R870",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 1,
					freq = 1,
					amount_max = 1,
					rank = 3,
					unit = "FBI_heavy_G36",
					tactics = self._tactics.swat_rifle_flank
				}
			}
		}
	elseif difficulty_index == 5 then
		self.enemy_spawn_groups.tac_swat_rifle_flank = {
			amount = {
				4,
				5
			},
			spawn = {
				{
					amount_min = 1,
					freq = 2,
					amount_max = 2,
					rank = 2,
					unit = "FBI_swat_M4",
					tactics = self._tactics.swat_rifle_flank
				},{
					amount_min = 0,
					freq = 1,
					amount_max = 1,
					rank = 2,
					unit = "FBI_swat_R870",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 2,
					freq = 2,
					amount_max = 2,
					rank = 3,
					unit = "FBI_heavy_G36",
					tactics = self._tactics.swat_rifle_flank
				},
				{
					amount_min = 0,
					freq = 0.2,
					amount_max = 1,
					rank = 2,
					unit = "medic_M4",
					tactics = self._tactics.swat_rifle_flank
				}
			}
		}
	end
end)

Hooks:PostHook(GroupAITweakData, "_init_task_data", "NewPoliciaSpawnRate", function(self, difficulty_index)
	
	-- Make our Hostage Rescue group not spawn during assaults
	self.besiege.assault.groups.tac_tazer_flanking = {0,0,0}
	
	-- Only between
	self.besiege.recon.groups = {
		tac_tazer_flanking = {
			0.1,
			0.1,
			0.1
		}
	}
end)
